
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "gen_f.h"     /* Only safe as first include in a ".c" file. */
                       /* Otherwise use gen.h.                       */

#include "do_cc.h"
#include "lib.h"
#include "cc.h"
#include "data.h"

/* -------------------------------------------------------------------------- */

int process_cc_command(char* arg, Colour_constancy_result* result_ptr)
{
    int                      prompt_to_increase_error_flag;
    int                      total_num_data_points;
    int                      num_data_points;
    int*                     data_point_nums;
    int                      res;
    Colour_constancy_methods cc_methods;

    ERE(get_cc_methods(arg, &cc_methods));

    ERE(total_num_data_points = get_num_data_points());
    ERE(num_data_points = parse_positive_integer_list(arg, 1, 
                                                      total_num_data_points,
                                                      &data_point_nums));

    prompt_to_increase_error_flag = is_interactive(); 

    if (cc_methods.plot_enable == NOT_SET)   cc_methods.plot_enable = TRUE;
    if (cc_methods.report_result == NOT_SET) cc_methods.report_result = TRUE;

    if (is_interactive())
    {
        set_io_atn_trap();
    }

    res = do_cc(&cc_methods, prompt_to_increase_error_flag, 
                num_data_points, data_point_nums, result_ptr);

    if (is_interactive())
    {
        unset_io_atn_trap();
    }

    kjb_free(data_point_nums);

    return res;
}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

