
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef FILE_DATA_INCLUDED
#define FILE_DATA_INCLUDED

#include "m/m_incl.h"
#include "type.h"

int set_data_files(const char* option, const char* value);

int get_selected_file_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int get_registered_file_data(Matrix** target_mpp);

int get_selected_registered_file_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

void get_file_data_source(char* source_buff, size_t max_len);

int get_num_file_data_points(void);

int file_data_is_up_to_date(int proposed_current_version);

int get_file_canon_data(Matrix** target_mpp);

int get_selected_file_canon_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int file_canon_data_is_up_to_date(int proposed_current_version);

int get_num_file_var_data_points(void);

int get_selected_file_var_data
(
    Matrix** dummy_target_mpp,
    int      dummy_num_data_points,
    int*     dummy_data_point_nums,
    Matrix** dummy_var_data_mpp 
);

int get_selected_registered_file_var_data
(
    Matrix** dummy_target_mpp,
    int      dummy_num_data_points,
    int*     dummy_data_point_nums 
);

int get_registered_file_var_data(Matrix** dummy_target_mpp);

#endif

