
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef ILLUM_DATA_INCLUDED
#define ILLUM_DATA_INCLUDED

#include "m/m_incl.h"
#include "type.h"

int set_illum_data_files(const char* option, const char* value);

int get_average_of_illum_gamut_data(Vector** target_vpp);

int make_illum_gamut(const char* make_directive, const char* file_name);

int get_sharp_illum_gamut(Matrix** target_mpp);

int make_actual_illum(const char* make_directive, const char* file_name);

int get_sharp_actual_illum(Vector** target_vpp);

int get_actual_illum(Vector** target_mpp);

int make_canon_illum(const char* make_directive, const char* file_name);

int get_sharp_canon_illum(Vector** target_vpp);

int get_canon_illum(Vector** target_vpp);

int get_illum_rgb_from_diagonal_transform
(
    Vector** illum_rgb_vpp,
    Vector*  diag_vp 
);

int get_map_to_canon_illum(Vector** map_vpp, const Vector* input_vp);

int ow_normalize_data_by_canon_illum_brightness(Matrix* mp);

#endif

