
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef IMAGE_INPUT_INCLUDED
#define IMAGE_INPUT_INCLUDED

#include "m/m_incl.h"
#include "type.h"

/* -------------------------------------------------------------------------- */

/* -------------------------------------------------------------------------- */

int set_image_files(const char* option, const char* value);

void get_image_data_source(char* source_buff, size_t max_len);

const KJB_image* get_input_image(int* version_ptr);
const KJB_image* get_canon_image(int* version_ptr);
const KJB_image* get_reduced_input_image(void);
const KJB_image* get_reduced_canon_image(void);

int input_image_is_up_to_date(int proposed_current_version);
int canon_image_is_up_to_date(int proposed_current_version);

#endif

