
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef C_COLOUR_SPACE_INCLUDED 
#define C_COLOUR_SPACE_INCLUDED
 
#include "m/m_gen.h"

#define LAB_F(arg)  \
            ((arg > 0.008856) ? pow(arg, 1.0/3.0) : 7.787 * arg + 16.0 / 116.0)

int set_colour_space_options(const char* option, const char* value);
int print_colour_space_options(void);

int get_rgb_to_xyz_matrix(Matrix** mpp);

int get_reciprocal_of_white_xyz
(
    Vector**      reciprocal_of_white_xyz_vpp,
    const Vector* white_rgb_vp 
);

int convert_matrix_rgb_to_lab
(
    Matrix**      out_mpp,
    const Matrix* in_mp,
    const Vector* white_rgb_vp 
);

int convert_matrix_rgb_to_xyz(Matrix** out_ipp, const Matrix* in_ip);

int convert_vector_rgb_to_lab
(
    Vector**      out_vpp,
    const Vector* in_vp,
    const Vector* white_rgb_vp 
);

int convert_vector_rgb_to_xyz(Vector** out_vpp, const Vector* in_vp);

#endif 

