
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef C_SHARP_INCLUDED 
#define C_SHARP_INCLUDED 

#include "m/m_gen.h"

int set_sharpening_transform_options
(
    const char* option,
    const char* value 
);

int sharpen_spectra
(
    Spectra**      sharpend_sp_ptr,
    const Spectra* sp,
    const Matrix*  sharpen_post_map_mp 
);

int fix_sharpen_map(Matrix** new_post_map_mpp, const Matrix* post_map_mp);

int get_db_sharp_transform
(
    Matrix**      T_mpp,
    const Matrix* data_mp,
    const Matrix* canon_data_mp 
);

int get_mip_db_sharp_transform
(
    Matrix**       T_mpp,
    const Spectra* reflect_spectra_sp,
    const Spectra* illum_spectra_sp,
    const Spectra* canon_spectra_sp,
    const Matrix*  initial_T_mp 
);

int sharp_db_mip_env_is_up_to_date(int version);

int get_two_mode_perfect_sharp_transform
(
    Matrix**       sharpen_post_map_mpp,
    const Spectra* sensor_sp,
    const Spectra* illum_sp,
    const Spectra* reflect_sp 
);

int get_canon_perfect_sharp_transform
(
    Matrix**       sharpen_post_map_mpp,
    const Spectra* sensor_sp,
    const Spectra* canon_sp,
    const Spectra* illum_sp,
    const Spectra* reflect_sp 
);

int get_standard_perfect_sharp_transform
(
    Matrix**       sharpen_post_map_mpp,
    const Spectra* sensor_sp,
    const Spectra* illum_sp,
    const Spectra* reflect_sp 
);

#endif 

