
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef C_TYPE_INCLUDED 
#define C_TYPE_INCLUDED 

#include "c/c_def.h"

typedef enum Projection_method
{
    /*
    // The first four are set based on backwards compatability. Hopefully all
    // the dependencies on the specific values have been purged, but by using
    // the same numeric values as before, things won't break regardless.
    */
    DIVIDE_BY_RED   = RED_INDEX,    /* 0 */
    DIVIDE_BY_GREEN = GREEN_INDEX,  /* 1 */
    DIVIDE_BY_BLUE  = BLUE_INDEX,   /* 2 */
    DIVIDE_BY_SUM   = 3,
    ONTO_RG_PLANE,
    ONTO_RB_PLANE,
    ONTO_GB_PLANE,
    ONTO_UNIT_SPHERE, 
    INVALID_PROJECTION_METHOD = ERROR
}
Projection_method;
    
#endif 

