
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef H_INTERSECT_INCLUDED 
#define H_INTERSECT_INCLUDED 

#include "m/m_gen.h"

int set_hull_intersect_options(const char* option, const char* value);

int intersect_positive_hulls
(
    Queue_element* hull_list_head, /* Address of start of hull list. */
    ulong          options,        /* Returned data structure flags. */
    Hull**         result_hp_ptr   /* Address of resulting hull. */       
);

int intersect_hulls
(
    Queue_element* hull_list_head, /* Address of start of hull list. */
    ulong          options,        /* Returned data structure flags. */
    Hull**         result_hp_ptr   /* Address of resulting hull. */       
);

int original_intersect_hulls
(
    Queue_element* hull_list_head, /* Address of start of hull list. */
    ulong          options,        /* Returned data structure flags. */
    Hull**         result_hp_ptr   /* Address of resulting hull. */         
);

int approximation_intersect_hulls
(
    Queue_element* hull_list_head,
    ulong          options,
    Hull**         result_hp_ptr 
);

int dual_space_intersect_hulls
(
    Queue_element* hull_list_head,
    ulong          options,
    Hull**         result_hp_ptr 
);

int find_point_in_2D_hull_intersection
(
    Queue_element* hull_list_head,
    int            resolution,
    Vector**       result_ptr,
    Matrix**       normal_mpp,
    Vector**       constrant_vpp 
);

int find_point_in_3D_hull_intersection
(
    Queue_element* hull_list_head,
    int            resolution,
    Vector**       result_ptr,
    Matrix**       normal_mpp,
    Vector**       constrant_vpp 
);

#endif 

