
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef H_QH_INCLUDED 
#define H_QH_INCLUDED 

#include "m/m_gen.h"

/* 
// This should be brought in via the makefile, but for now, lets just
// force it.
*/
#define HAVE_QHULL 

int set_qhull_options(const char* option, const char* value);

int qh_find_convex_hull
(
    Matrix*         points_mp,
    int*            num_vertices_ptr,
    int*            num_facets_ptr,
    Matrix**        vertex_mpp,
    Matrix**        normal_mpp,
    Vector**        b_value_vpp,
    Matrix_vector** facet_mp_list_ptr,
    FILE*           geom_view_geometry_fp 
);

#endif 

