
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "h/h_gen_f.h"     /* Only safe as first include in a ".c" file. */ 

#include "h/h_set.h"
#include "h/h_hull.h"
#include "h/h_ave.h"
#include "h/h_intersect.h"
#include "h/h_misc.h"

/* -------------------------------------------------------------------------- */
/*
 * =============================================================================
 *                                  kjb_h_set
 *
 *
 *
 *
 * -----------------------------------------------------------------------------
 */

int kjb_h_set(const char* option, const char* value)
{ 
    int         temp_result; 
    int         result = NOT_FOUND; 
    int         (**set_fn_ptr)(const char*, const char*); 

    static int  (*set_fn[])(const char*, const char*) = 
                                    {
                                        set_hull_options, 
                                        set_hull_ave_options, 
                                        set_hull_intersect_options, 
                                        set_hull_misc_options, 
                                        NULL
                                    }; 

    set_fn_ptr = set_fn;

    while (*set_fn_ptr != NULL)
    {
        ERE(temp_result = (**set_fn_ptr)(option, value));

        if (temp_result == NO_ERROR) result = NO_ERROR; 

        set_fn_ptr++;
    }

    return result; 
}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

