
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "i/i_gen_f.h"     /* Only safe as first include in a ".c" file. */ 
#include "i/i_html.h"

/* -------------------------------------------------------------------------- */

int output_image_for_html
(
    const KJB_image* ip,
    FILE*            index_fp,
    const char*      dir,
    const char*      file_name 
)
{
    char file_path[ MAX_FILE_NAME_SIZE ]; 

    ERE(kjb_fprintf(index_fp, 
                    "<IMG SRC=%s.gif HEIGHT=%d WIDTH=%d>\n",
                    file_name, ip->num_rows, ip->num_cols));

    ERE(kjb_sprintf(file_path, sizeof(file_path), "%s%s%s.gif", 
                    dir, DIR_STR, file_name)); 

    ERE(kjb_write_image(ip, file_path));

    /* Do a tiff version to for better quality if needed. */

    ERE(kjb_sprintf(file_path, sizeof(file_path), "%s%s%s.tif", 
                    dir, DIR_STR, file_name)); 

    ERE(kjb_write_image(ip, file_path));

    return NO_ERROR;
}

