
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "i/i_gen_f.h"     /* Only safe as first include in a ".c" file. */ 
#include "i/i_lib.h"

#define IMAGE_FILE_SUFFIXES                                                    \
    {                                                                          \
        "kiff", "kif", "mid", "miff", "tiff", "tif", "viff", "gif", "gif87",   \
        "ps", "eps", "sun", "ras", "jpeg", "jpg", "pcd", "pict", "pnm", "sgi", \
        "xbm", "xpm", "r16", NULL                                              \
    }

/* -------------------------------------------------------------------------- */

int get_image_file_base_path
(
    const char* file_path,
    char*       base_path,
    size_t      base_path_size,
    char*       suffix,
    size_t      suffix_size 
)
{
    static const char* suffixes[ ]  = IMAGE_FILE_SUFFIXES;
 
    return get_base_path(file_path, base_path, base_path_size, 
                         suffix, suffix_size, suffixes);      

}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

int get_image_file_base_name
(
    const char* file_name,
    char*       dir_str,
    size_t      dir_str_size,
    char*       base_name,
    size_t      base_name_size,
    char*       suffix,
    size_t      suffix_size 
)
{
    static const char* suffixes[ ]  = IMAGE_FILE_SUFFIXES;
 
    return get_base_name(file_name, dir_str, dir_str_size,
                         base_name, base_name_size,
                         suffix, suffix_size, suffixes);      
}

