
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef I_MATRIX_INCLUDED 
#define I_MATRIX_INCLUDED 
 
#include "l/l_def.h"
#include "m/m_matrix.h"
#include "i/i_type.h"

int rgb_matrix_vector_to_image
(
    Matrix*     mp_list[ 3 ],
    KJB_image** out_ip_arg 
);

int image_to_rgb_matrix_vector(const KJB_image* ip, Matrix* mp_list[ 3 ]);

int rgb_matrices_to_image
(
    Matrix*     r_mp,
    Matrix*     g_mp,
    Matrix*     b_mp,
    KJB_image** out_ip_arg 
);

int image_to_rgb_matrices
(
    const KJB_image* ip,
    Matrix**         r_mpp,
    Matrix**         g_mpp,
    Matrix**         b_mpp 
);

void free_rgb_matrices(Matrix* r_mp, Matrix* g_mp, Matrix* b_mp);

void free_rgb_matrix_vector(Matrix* mp_list[ 3 ]);

#endif 

