
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef I_VIDEO_INCLUDED 
#define I_VIDEO_INCLUDED
 
#include "l/l_def.h"
#include "i/i_type.h"

/* -------------------------------------------------------------------------- */

#define FULL_VIDEO_NUM_ROWS  478  
#define FULL_VIDEO_NUM_COLS  638 

#define STRIP_TOP      8
#define STRIP_BOTTOM   2
#define STRIP_LEFT     1
#define STRIP_RIGHT    0

#define STRIPPED_VIDEO_NUM_ROWS    \
                        (FULL_VIDEO_NUM_ROWS - STRIP_TOP - STRIP_BOTTOM)

#define STRIPPED_VIDEO_NUM_COLS   \
                        (FULL_VIDEO_NUM_COLS - STRIP_LEFT - STRIP_RIGHT)

/* -------------------------------------------------------------------------- */

int set_video_options(const char* option, const char* value);
int set_capture_frame_count(int new_value);
int get_capture_frame_count(void);
int start_video_grabber(void);
int stop_video_grabber(void);

int capture_image(KJB_image** ipp, Image_window* image_window_ptr);

#endif 

