
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef L_SORT_INCLUDED 
#define L_SORT_INCLUDED

#include "l/l_def.h"

#define USE_CURRENT_ATN_HANDLING       -10
#define USE_SORT_ATN_HANDLING          -11
#define DISABLE_ATN_HANDLING           -12

#define EQUAL_ITEMS            0
#define FIRST_ITEM_GREATER     1
#define SECOND_ITEM_GREATER    (-1)

int kjb_sort
(
    void*  array,
    int    num_elements,
    size_t element_size,
    int    (*cmp_fn) (const void*, const void*),
    int    interrupt_action 
);

int int_sort
(
    void*  array,
    int    num_elements,
    size_t element_size,
    size_t key_pos,
    int    interrupt_action 
);

int binary_search
(
    void*       array,
    int         num_elements,
    size_t      element_size,
    int         (*cmp_fn) (const void*, const void*),
    const void* search_key_ptr 
);

int int_binary_search
(
    void*  array,
    int    num_elements,
    size_t element_size,
    size_t element_offset,
    int    search_key 
);

int linear_search
(
    void*  array,
    int    num_elements,
    size_t element_size,
    int    (*cmp_fn) (const void*, const void*),
    void*  search_key_ptr 
);

int int_linear_search(int* array, int num_elements, int search_elem);

int insert_into_sorted_array
(
    void*  array,
    int*   num_elements_ptr,
    size_t element_size,
    int    (*cmp_fn)(const void*, const void*),
    void*  new_element_ptr 
);

#endif 

