
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "l/l_gen_f.h"     /* Only safe as first include in a ".c" file. */ 

#ifdef X11_IS_POSSIBLE
/*Some versions of makedepend cannot be trusted to honor the "-Y" option. */
#ifndef MAKE_DEPEND
#    include <Xlib.h> 
#endif 
#endif

#include "l/l_sys_X11.h" 

int X11_is_ok(void)
{
#ifdef X11_IS_POSSIBLE
    static int cached_result = NOT_SET; 
    Display *display;

    if (cached_result == NOT_SET)
    {
        display = XOpenDisplay((char*)NULL);

        if (display == NULL) 
        {
            cached_result = FALSE;
        }
        else 
        {
            XCloseDisplay(display);
            cached_result = TRUE;
        }
    }

    return cached_result;
#else
    return FALSE;
#endif
}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

int ring_X11_bell(void)
{
#ifdef X11_IS_POSSIBLE
    Display *display;

    display = XOpenDisplay((char*)NULL);

    if (display == NULL) 
    {
        return ERROR;
    }
    else 
    {
        XBell(display, 100);
        XCloseDisplay(display);
    }

    return NO_ERROR;
#else
    return ERROR;
#endif
}

