
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef L_S_SCAN_INCLUDED 
#define L_S_SCAN_INCLUDED

#include "l/l_def.h"

#ifdef INT32_IS_LONG
#    define ss1i32     ss1l
#    define ss1pi32    ss1pl
#    define ss1pi32_2  ss1pl_2
#else
#ifdef INT32_IS_INT 
#    define ss1i32     ss1i
#    define ss1pi32    ss1pi
#    define ss1pi32_2  ss1pi_2
#endif
#endif

#ifdef INT16_IS_INT
#    define ss1i16     ss1i
#    define ss1pi16    ss1pi
#    define ss1pi16_2  ss1pi_2
#else
#ifdef INT16_IS_SHORT
#    define ss1i16     ss1s
#    define ss1pi16    ss1ps
#    define ss1pi16_2  ss1ps_2
#endif
#endif

/* ------------------------------------------------------------------------- */

int ss1l(const char*, long*);
int ss1pl(const char*, long*);
int ss1pl_2(const char*, long*);
int ss1i(const char*, int*);
int ss1pi(const char*, int*);
int ss1pi_2(const char*, int*);
int ss1s(const char*, short*);
int ss1ps(const char*, short*);
int ss1ps_2(const char*, short*);
int ss1f(const char*, float*);
int ss1d(const char*, double*);
int ss1snf(const char*, float*);
int ss1snd(const char*, double*);

int is_scientific_notation_number(const char*);

#endif 

