
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef M_ERROR_INCLUDED 
#define M_ERROR_INCLUDED 

#include "m/m_gen.h"

#define USE_COMPARE_WITH_REAL_MAX_FOR_DIVIDE_BY_ZERO 
/* #define USE_IS_ZERO_DBL_FOR_DIVIDE_BY_ZERO */

#ifdef TEST

#    define SET_DIVIDE_BY_ZERO_ERROR()  \
                          set_divide_by_zero_error(__LINE__, __FILE__)

#    define SET_OVERFLOW_ERROR()  \
                          set_overflow_error(__LINE__, __FILE__)

#else
#    define SET_DIVIDE_BY_ZERO_ERROR() set_divide_by_zero_error()
#    define SET_OVERFLOW_ERROR()       set_overflow_error()
#endif
  
int check_same_matrix_dimensions
(
    const Matrix* ,
    const Matrix* ,
    const char*    
);

int check_same_vector_lengths
(
    const Vector* ,
    const Vector* ,
    const char*    
);

Matrix* expand_error_box(const Matrix*);
Matrix* create_error_points(const Matrix*, double);

int get_expanded_error_box(Matrix** result_mpp, const Matrix* mp);

int get_points_with_error
(
    Matrix**      result_mpp,
    const Matrix* mp,
    double        abs_err,
    double        rel_err,
    double        min_valid_value 
);

#ifdef TEST
    void set_divide_by_zero_error(int, const char*);
    void set_overflow_error(int, const char*);
#else
    void set_divide_by_zero_error(void);
    void set_overflow_error(void);
#endif

int check_quadratic_constraints
(
    const Vector* result_vp,
    const Matrix* le_constraint_mp,
    const Vector* b_vp,
    const Vector* lb_constraint_vp,
    const Vector* ub_constraint_vp 
);

#endif 

