
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef M_MAT_STAT_INCLUDED 
#define M_MAT_STAT_INCLUDED 

#include "m/m_gen.h"
#include "m/m_vec_stat.h"

double get_matrix_mean(const Matrix* mp);

int sum_matrix_cols_without_negatives
(
    Vector**      output_vpp,
    const Matrix* input_mp 
);

int average_matrix_cols_without_negatives
(
    Vector**      output_vpp,
    const Matrix* input_mp 
);

int average_matrix_cols(Vector** output_vpp, const Matrix* input_mp);

int sum_matrix_rows_without_negatives
(
    Vector**      output_vpp,
    const Matrix* input_mp 
);

int average_matrix_rows_without_negatives
(
    Vector**      output_vpp,
    const Matrix* input_mp 
);

int average_matrix_rows(Vector** output_vpp, const Matrix* input_mp);

int sum_matrix_rows(Vector** output_vpp, const Matrix* input_mp);

int sum_matrix_cols(Vector** output_vpp, const Matrix* input_mp);

int get_matrix_row_stats
(
    const Matrix* mp,
    Vector**      mean_vpp,
    Vector**      stdev_vpp 
);

int get_fixed_clustering_of_3D_data
(
    Matrix**      result_mpp,
    const Matrix* mp,
    int           resolution 
);

int get_fixed_cluster_average_of_3D_data
(
    Vector**      result_vpp,
    const Matrix* mp,
    int           resolution 
);

#endif 

