
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef M_VEC_ARITH_INCLUDED 
#define M_VEC_ARITH_INCLUDED 

#include "m/m_gen.h"

int multiply_vector_by_scalar
(
    Vector**      target_vpp,
    const Vector* source_vp,
    double        scalar 
);

int ow_multiply_vector_by_scalar(Vector* source_vp, double scalar);

int divide_vector_by_scalar
(
    Vector**      target_vpp,
    const Vector* source_vp,
    double        scalar 
);

int ow_divide_vector_by_scalar_without_negatives
(
    Vector* source_vp,
    double  scalar 
);

int ow_divide_vector_by_scalar(Vector* source_vp, double scalar);

int add_scalar_to_vector
(
    Vector**      target_vpp,
    const Vector* source_vp,
    double        scalar 
);

int ow_add_scalar_to_vector(Vector* source_vp, double scalar);

int subtract_scalar_from_vector
(
    Vector**      target_vpp,
    const Vector* source_vp,
    double        scalar 
);

int ow_subtract_scalar_from_vector(Vector* source_vp, double scalar);

int add_vectors_without_negatives
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int add_vectors
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int subtract_vectors_without_negaives
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int subtract_vectors
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int multiply_vectors
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int divide_vectors
(
    Vector**      target_vpp,
    const Vector* first_vp,
    const Vector* second_vp 
);

int ow_add_scalar_times_vector_to_vector
(
    Vector*       first_vp,
    const Vector* second_vp,
    double        scalar 
);

int ow_add_vectors(Vector* first_vp, const Vector* second_vp);

int ow_subtract_vectors(Vector* first_vp, const Vector* second_vp);

int ow_multiply_vectors(Vector* first_vp, const Vector* second_vp);

int ow_divide_vectors(Vector* first_vp, const Vector* second_vp);

int invert_vector(Vector** target_vpp, const Vector* source_vp);

int sqrt_vector(Vector** target_vpp, const Vector* vp);

int log_vector(Vector** target_vpp, const Vector* vp, double log_zero);

int exp_vector(Vector** target_vpp, const Vector* vp);

int get_abs_of_vector(Vector** target_vpp, const Vector* source_vp);

int ow_invert_vector(Vector* vp);
int ow_sqrt_vector(Vector* vp);

int ow_log_vector(Vector* vp, double log_zero);

int ow_exp_vector(Vector* vp);
int ow_get_abs_of_vector(Vector* vp);

double sum_vector_elements(const Vector* vp);
double multiply_vector_elements(const Vector* vp);

#endif 

