
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef M_VEC_STAT_INCLUDED 
#define M_VEC_STAT_INCLUDED 

#include "m/m_gen.h"
#include "m/m_stat.h"

/* -------------------------------------------------------------------------- */

typedef struct Vector_stat 
{   
    int n; 
    Vector *mean_vp;
    Vector *stdev_vp;
    Vector *min_vp;
    Vector *max_vp;
}   
Vector_stat;  

/* -------------------------------------------------------------------------- */

double       get_vector_mean      (const Vector* vp);
int          add_vector_data_point(const Vector*);
Vector_stat* get_vector_data_stats(void);
void         free_vector_stat     (Vector_stat*);
int          clear_vector_stats   (void);
void         cleanup_vector_stats (void);
Stat*        get_vector_stats     (const Vector*);

#endif 

