
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef SYNTHETIC_DATA_INCLUDED
#define SYNTHETIC_DATA_INCLUDED

#include "m/m_incl.h"
#include "type.h"

int set_synthetic_data_options(const char* option, const char* value);

int get_num_synthetic_data_points(void);

int get_selected_synthetic_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int get_selected_registered_synthetic_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int get_registered_synthetic_data(Matrix** target_mpp);

int get_synthetic_matte_data(Matrix** target_mpp);

int synthetic_matte_data_is_up_to_date(int proposed_version);

int get_selected_synthetic_canon_data
(
    Matrix** target_mpp,
    int      num_canon_data_points,
    int*     canon_data_point_nums 
);

int get_selected_synthetic_canon_data
(
    Matrix** target_mpp,
    int      num_canon_data_points,
    int*     canon_data_point_nums 
);

int get_synthetic_canon_data(Matrix** target_mpp);

int get_synthetic_matte_canon_data(Matrix** target_mpp);

int synthetic_matte_canon_data_is_up_to_date(int proposed_version);

int get_num_synthetic_var_data_points(void);

int get_selected_synthetic_var_data
(
    Matrix** dummy_target_mpp,
    int      dummy_num_data_points,
    int*     dummy_data_point_nums,
    Matrix** dummy_var_data_mpp 
);

int get_selected_registered_synthetic_var_data
(
    Matrix** dummy_target_mpp,
    int      dummy_num_data_points,
    int*     dummy_data_point_nums 
);

int get_registered_synthetic_var_data(Matrix** dummy_target_mpp);

int make_data(const char* make_directive, const char* file_name);

int make_matte_canon_data(int dry_run);

int make_canon_data(const char* make_directive, const char* file_name);

#endif

