
/* =========================================================================== *
|  
|  Copyright (c) 1994-2002 by Kobus Barnard (author). 
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "gen_f.h"     /* Only safe as first include in a ".c" file. */
                       /* Otherwise use gen.h.                       */

#include "version.h"

/* -------------------------------------------------------------------------- */

/*
// We put print_version in a separate file so that we can force compiling it
// with every compile with minimal overhead. We wish to force the compile of
// this routine so that the compilation time is correct.
*/

int print_version(void)
{
    char compile_time_str[ 10 ]; 

    BUFF_CPY(compile_time_str, __TIME__);
    compile_time_str[ 5 ] = '\0'; 

    ERE(pso("\nGamut version %d.%d.%d%s (%s, %s).\n",
            MAJOR_VERSION, MINOR_VERSION, PATCH_LEVEL, DEVELOPMENT_STAGE,
            __DATE__, compile_time_str));

    if (DEVELOPMENT_MESSAGE[ 0 ] != '\0')
    {
        pso("\n  [  %s  ]\n\n", DEVELOPMENT_MESSAGE);
    }

    ERE(pso("\nWritten by Kobus Barnard with help from Lindsay Martin.\n\n")); 

    if ( ! is_interactive() )
    {
        char host_str[ 100 ];
        char cur_time_str[ 100 ]; 

        if (    (BUFF_GET_ENV("HOST", host_str) != ERROR)
             && (BUFF_GET_TIME(cur_time_str) != ERROR)
           )
        {
            pso("\n  [ Process %ld on %s (started at %s) ]\n\n", 
                (long)MY_PID, host_str, cur_time_str); 
        }
    }
            
    ERE(kjb_fflush(stdout));

    return NO_ERROR;
}

