
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef DATA_INCLUDED
#define DATA_INCLUDED

#include "m/m_incl.h"
#include "type.h"

EXTERN_C int                       
(
    set_data_options (const char* option, const char* value) 
);

void get_data_source           (char* source_buff, size_t max_len);
int  force_image_data          (void);
int  request_image_data        (void);
int  force_synthetic_data      (void);
int  request_synthetic_data    (void);
int  force_file_data           (void);
int  request_file_data         (void);
int  force_image_var_data      (void);
int  request_image_var_data    (void);
int  force_synthetic_var_data  (void);
int  request_synthetic_var_data(void);
int  force_file_var_data       (void);
int  request_file_var_data     (void);
int  restore_data_source       (void);
int  get_num_data_points       (void);

int get_selected_derived_data
(
    Matrix** result_mpp,
    int      num_data_points,
    int*     data_point_nums
);

int get_sharp_selected_registered_data
(
    Matrix** result_mpp,
    int      num_data_points,
    int*     data_point_nums
);

int get_sharp_registered_data(Matrix** result_mpp);

int get_selected_registered_data
(
    Matrix** result_mpp,
    int      num_data_points,
    int*     data_point_nums
);

int get_registered_data(Matrix** result_mpp);

int get_sharp_selected_canon_data
(
    Matrix** selected_canon_data_mpp,
    int      num_data_points,
    int*     data_point_nums
);

int get_selected_canon_data
(
    Matrix** selected_canon_data_mpp,
    int      num_data_points,
    int*     data_point_nums
);

int get_canon_data(Matrix** canon_data_mpp);

int get_sharp_canon_data(Matrix** canon_data_mpp);

#endif

