
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef DO_ERROR_REPORT_INCLUDED
#define DO_ERROR_REPORT_INCLUDED

#include "l/l_incl.h"
#include "type.h"

EXTERN_C int set_report_options(const char* option, const char* value);

int do_error_report
(
    Colour_constancy_error* error_one_ptr,
    Colour_constancy_error* error_two_ptr,
    Input_data_error*       input_data_error_one_ptr,
    Input_data_error*       input_data_error_two_ptr,
    const char*             heading,
    const char*             error_stat_one_str,
    const char*             error_stat_two_str
);

int do_luminance_error_report(void);
int do_luminance_factor_report(void);
int do_cumulative_luminance_report(void);
int do_grand_total_luminance_report(void);

#endif

