
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef GLOBAL_INCLUDED
#define GLOBAL_INCLUDED

#include "gen.h"

#ifdef GLOBAL_DEF
#    undef GLOBAL_DEF
#endif

#ifdef GLOBAL_INIT
#    undef GLOBAL_INIT
#endif

#ifdef ALLOCATE_GLOBAL_STORAGE
#    define GLOBAL_DEF  EXPORT
#    define GLOBAL_INIT(x) x
#else
#    define GLOBAL_DEF  IMPORT
#    define GLOBAL_INIT(x)
#endif

/* -------------------------------------------------------------------------- */

GLOBAL_DEF Negative_data_action
                  negative_3D_data_action GLOBAL_INIT(=SKIP_NEGATIVE_DATA);

/*
// Only one of min_absolute_pixel_error and min_relative_pixel_error can be
// positive. (A negative value, by convention DBL_NOT_SET, disables the
// value.) The pixel and diagonal model errors are minimums because they can be
// increased when there is no hull intersection.
*/
GLOBAL_DEF double  min_absolute_pixel_error     GLOBAL_INIT( = DBL_HALF_MOST_NEGATIVE );
GLOBAL_DEF double  min_relative_pixel_error     GLOBAL_INIT( = DBL_HALF_MOST_NEGATIVE );

GLOBAL_DEF double  min_relative_diag_error      GLOBAL_INIT( = 0.05 );

GLOBAL_DEF double    relative_sensor_error        GLOBAL_INIT( = 0.02  );

GLOBAL_DEF int     use_data_hull                GLOBAL_INIT( = TRUE );

/* -------------------------------------------------------------------------- */

GLOBAL_DEF int print_plot_style GLOBAL_INIT( = FALSE );
GLOBAL_DEF int prompt_for_plots GLOBAL_INIT( = FALSE );
GLOBAL_DEF int plot_illumination_constraint GLOBAL_INIT( = TRUE);

/* -------------------------------------------------------------------------- */

#undef GLOBAL_DEF
#undef GLOBAL_INIT

#endif

