
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef LUMINANCE_INCLUDED
#define LUMINANCE_INCLUDED

#include "m/m_incl.h"
#include "type.h"

EXTERN_C int set_luminance_options(const char* option, const char* value);

int do_luminance(const Matrix* data_mp);
int do_current_luminance_error_report(int dry_run);
int do_cumulative_luminance_error_report(int dry_run);
int reset_cumulative_luminance_error(void);
int do_grand_total_luminance_error_report(int dry_run);
int do_luminance_factors(const Matrix* data_mp);
int do_current_luminance_factor_report(int dry_run);
int do_cumulative_luminance_factor_report(int dry_run);
int reset_cumulative_luminance_factor(void);
int do_grand_total_luminance_factor_report(int dry_run);

int make_luminance(const char* make_directive, const char* directory);

int get_sum_luminance
(
    const Matrix* data_mp,
    double        luminance_estimate[ MAX_NUM_LUMINANCE_METHODS ]
);

#endif

