
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#include "gen.h"     /* Only safe as first include in a ".c" file. */
                       /* Otherwise use gen.h.                       */

#include "luminance.h"
#include "stat.h"
#include "reset.h"

/* -------------------------------------------------------------------------- */

static int reset_var_illum_maps(void);

/* -------------------------------------------------------------------------- */

int process_reset_command(char* arg)
{

    trim_beg(&arg);

    if (IC_STRCMP_EQ(arg, "error"))
    {
        initialize_cumulative_error();
        ERE(reset_cumulative_luminance_error());
    }
    else if (IC_STRCMP_EQ(arg, "luminance-factors"))
    {
        ERE(reset_cumulative_luminance_factor());
    }
    else if (IC_STRCMP_EQ(arg, "vid"))
    {
        ERE(reset_var_illum_maps());
    }
    else if ((IC_STRCMP_EQ(arg, "all")) || (IC_STRCMP_EQ(arg, "total")))
    {
        initialize_grand_total_error();  /* Also does cumulative. */
        ERE(reset_var_illum_maps());
        ERE(reset_cumulative_luminance_factor());
        ERE(reset_cumulative_luminance_error());
    }
    else if (*arg == '\0')
    {
        initialize_cumulative_error();
        ERE(reset_var_illum_maps());
        ERE(reset_cumulative_luminance_factor());
        ERE(reset_cumulative_luminance_error());
    }
    else
    {
        set_error("Invalid argument for reset command.");
        return ERROR;
    }

    return NO_ERROR;
}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

static int reset_var_illum_maps(void)
{

    return NO_ERROR;
}

/*  /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\ /\   */

