
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef SHARP_INCLUDED
#define SHARP_INCLUDED

#include "m/m_incl.h"
#include "type.h"

int make_sharp(const char* make_directive, const char* file_name);

int write_sharpening_transform
(
    char* request,
    char* output_file,
    int   append_flag
);

int write_sharp_sensors
(
    char* request,
    char* output_file,
    int   append_flag
);

EXTERN_C int set_sharp_file(const char* option, const char* value);

int set_sharpening
(
    Sharp_method sharp_method,
    int          num_data_points,
    int*         data_point_nums,
    Vector*      illum_hp
);

Sharp_method get_current_sharp_method(void);

void get_current_sharp_method_string(char* buff, size_t max_len);

void get_sharp_method_string
(
    Sharp_method sharp_method,
    char*        buff,
    size_t       max_len
);

int get_sharp_version(void);

int sharpen_matrix_data(Matrix** sharp_data_mpp, Matrix* data_mp);

int ow_sharpen_matrix_data(Matrix* data_mp);

int unsharpen_matrix_data(Matrix** data_mpp, Matrix* sharp_data_mp);

int ow_unsharpen_matrix_data(Matrix* data_mp);
int ow_sharpen_vector_data(Vector* data_vp);

int sharpen_vector_data(Vector** sharp_data_vpp, Vector* data_vp);

int ow_unsharpen_vector_data(Vector* data_vp);

int unsharpen_vector_data(Vector** data_vpp, Vector* sharp_data_vp);

int sharpen_rgb
(
    double* sharp_R_ptr,
    double* sharp_G_ptr,
    double* sharp_B_ptr,
    double  R,
    double  G,
    double  B
);

int unsharpen_rgb
(
    double* sharp_R_ptr,
    double* sharp_G_ptr,
    double* sharp_B_ptr,
    double  R,
    double  G,
    double  B
);

int map_projected_sharp_image
(
    KJB_image**      target_ipp,
    const KJB_image* in_ip,
    Matrix*          map_mp
);

int map_sharp_image
(
    KJB_image**      target_ipp,
    const KJB_image* in_ip,
    Matrix*          map_mp
);

int get_fixed_sharp_maps_by_algorithm
(
    Result_by_algorithm* fixed_sharp_result_ptr,
    Result_by_algorithm* dull_result_ptr
);

#endif

