
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef STAT_INCLUDED
#define STAT_INCLUDED

#include "l/l_incl.h"
#include "m/m_incl.h"
#include "type.h"

EXTERN_C int set_stat_options(const char* option, const char* value);

void initialize_cumulative_error(void);
void initialize_grand_total_error(void);

int update_cumulative_error
(
    int                     sharp_methods[ NUM_SHARP_METHODS ],
    Colour_constancy_error*
);

int update_cumulative_input_data_error
(
    int               sharp_methods[ NUM_SHARP_METHODS ],
    Input_data_error*
);

int do_grand_total_error_report(char* label);
int do_cumulative_error_report(char* label);

int calculate_cumulative_error_stats
(
    double  count,
    double  default_to_dull_count,
    double  error_sum,
    double  error_max,
    double  error_sum_sqr,
    double* error_stat_one_ptr,
    double* error_stat_two_ptr
);

#endif

