#!/usr/bin/env perl
# $Id: boost_warn_filter.pl 13504 2012-12-19 19:27:17Z predoehl $
#use strict; use warnings; # turned off in "production" mode, for speed.
my $any_path = "[\\w/-]*";                          # foo/bar//baz (no dots!)
my $boost_path = "$any_path/boost/$any_path";       # foo/bar/baz//boost/frob/
my $fun_name = "['][^']+[']";                       # 'foo bar baz'
my $extension = "\\.[ch](?:pp)?";                   # ONE OF .h .hpp .c .cpp
my $from_a_file = "\\s*from $any_path$extension:\\d+";# from foo/bar/baz.cpp:37
my $from_chain = "(?:(?:$from_a_file,\n)*$from_a_file:\n)";
my $in_file = "(?:^In file included$from_chain)";
my $be = "^$boost_path$extension:";                 # /foo/boost/bar/baz.hpp:
my $in_fun = "(?:$be In(?: static)?(?: member)? function $fun_name:\n)";
my $ins_from = "(?:$any_path$extension:\\d+:\\s*instantiated from)";
my $ins_chain = "(?:(?:$ins_from $fun_name\n)*$ins_from here\n)";
my $location = "\\d+:(?:\\d+:)?";                   # line#, optional column#
my $warn_proper = "(?:^$boost_path\\.hpp:$location warning:.*\n)";
my $at_global = "(?:$be At global scope:\n)";
my $in_ins_of = "(?:$be In instantiation of $fun_name:\n)";
my $prefix1 = "(?:$in_file?$in_fun?)";
my $prefix2 = "(?:$at_global$in_ins_of)";
my $boost_warning = "(?:(?:$prefix1|$prefix2)$ins_chain?$warn_proper+)";
{
    local $/;   # slurp mode
    while (<STDIN>) {
        s!$boost_warning!!gmo;
        die "$_\n" if /Compile status is: [^0]/;
        print;
    }
}
