
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Lindsay Martin and Kobus Barnard (authors).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef CORRELATION_INCLUDED
#define CORRELATION_INCLUDED

#include "l/l_incl.h"
#include "m/m_incl.h"
#include "corr_lib.h"

EXTERN_C int             
(
    set_correlation_options (const char* option, const char* value) 
);

int      make_correlation
(
    const char* make_directive,
    const char* file_name 
);

int      do_correlation  
(
    Colour_constancy_methods* cc_methods_ptr,
    Matrix*                   data_mp,
    int                       prompt_to_increase_error_flag,
    Correlation_result*       corr_result_ptr,
    Correlation_error*        cpu_time_ptr 
);

#endif

