
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef IMAGE_DATA_INCLUDED
#define IMAGE_DATA_INCLUDED

#include "m/m_incl.h"
#include "type.h"

/* -------------------------------------------------------------------------- */

EXTERN_C int     set_image_pp_options                  
(
    const char* option,
    const char* value 
);

int              get_num_image_data_points             (void);

int              get_selected_registered_image_data    
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int              get_registered_image_data             
(
    Matrix** target_mpp 
);

int              get_selected_image_data               
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int              get_selected_image_canon_data         
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int              get_image_canon_data                  
(
    Matrix** target_mpp 
);

int              get_num_image_var_data_points         (void);

int              get_selected_image_var_data           
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums,
    Matrix** var_data_mpp 
);

int              get_selected_registered_image_var_data
(
    Matrix** target_mpp,
    int      num_data_points,
    int*     data_point_nums 
);

int              get_registered_image_var_data         
(
    Matrix** target_mpp 
);

const KJB_image* get_pp_input_image                    (void);

#endif

