
/* =========================================================================== *
|
|  Copyright (c) 1994-2002 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowleged in publications, and relevent papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarentee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef PLOT_INCLUDED
#define PLOT_INCLUDED

/* -------------------------------------------------------------------------- */

int process_plot_command(char* line_pos);
EXTERN_C int set_plot_options(const char* option, const char* value);

int plot_2D_result
(
    int                  plot_id,
    int                  hull_intersection_flag,
    int                  canon_gamut_num,
    Result_by_algorithm* result_ptr,
    Hull_result*         hull_result_ptr,
    double               illum_hull_x_max,
    double               illum_hull_y_max
);

int plot_3D_result
(
    int                  plot_id,
    int                  plot_all_hulls_flag,
    int                  canon_gamut_num,
    Result_by_algorithm* result_ptr,
    Hull_result*         hull_result_ptr
);

int plot_data_projection(int plot_id, Matrix* rgb_mp, const char* title);

int plot_3D_hull_projection
(
    int         plot_id,
    Hull*       hp,
    const char* title,
    Vector**    min_vpp,
    Vector**    max_vpp
);

int plot_3D_hull_list_projection
(
    int         plot_id,
    int         num_hulls,
    Hull**      hp_list,
    const char* title
);

int plot_projected_black_body_curve
(
    int     plot_id,
    Vector* canon_illum_vp,
    int     dim
);

#endif

